'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.QMLRenderer = exports.registerNativeComponentClass = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _Registry = require('./Registry');

Object.defineProperty(exports, 'registerNativeComponentClass', {
  enumerable: true,
  get: function get() {
    return _Registry.registerNativeComponentClass;
  }
});
exports.render = render;

var _reactReconciler = require('react-reconciler');

var _reactReconciler2 = _interopRequireDefault(_reactReconciler);

var _QMLComponent = require('./QMLComponent');

var QMLComponent = _interopRequireWildcard(_QMLComponent);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function createElement(type, props, rootContainerElement) {
  // console.log('  props', JSON.stringify(props));

  if (_Registry.Registry[type]) {
    // return Registry[type];
    var _Registry$type = _Registry.Registry[type],
        qmlContent = _Registry$type.qmlContent,
        defautlProp = _Registry$type.defautlProp;

    var obj = Qt.createQmlObject(qmlContent, rootContainerElement, type);

    return obj;
    // return {
    //   qmlObject: obj
    // }
  }

  return null;
}

var children = new WeakMap();

var QMLRenderer = exports.QMLRenderer = (0, _reactReconciler2.default)({
  appendInitialChild: function appendInitialChild(parentInstance, child) {

    // parentInstance._children = [child];
    var childrenArray = children.get(parentInstance) || [];
    childrenArray.push(child);
    children.set(parentInstance, childrenArray);
  },
  createInstance: function createInstance(type, props, rootInstance) {
    return createElement(type, props, rootInstance);
  },
  createTextInstance: function createTextInstance(text, rootContainerInstance) {
    return getOwnerDocument(rootContainerInstance).createTextNode(text);
  },
  finalizeInitialChildren: function finalizeInitialChildren(parent, type, props, rootContainerInstance) {

    var reactChild = children.get(parent);
    var defaultProp = _Registry.Registry[type].defaultProp;


    if (reactChild) {
      // console.log('  reactChild.parent', reactChild.parent);
      if (parent[defaultProp].push) {
        parent[defaultProp].length = 0;
        reactChild.forEach(function (child) {
          parent[defaultProp].push(child);
        });
      } else {
        parent[defaultProp] = reactChild[0];
      }
    }

    QMLComponent.setInitialProps(parent, props, rootContainerInstance);
  },
  getPublicInstance: function getPublicInstance(inst) {
    return inst;
  },
  prepareForCommit: function prepareForCommit() {},
  prepareUpdate: function prepareUpdate(domElement, type, oldProps, newProps) {
    return QMLComponent.diffProps(domElement, oldProps, newProps);
  },
  resetAfterCommit: function resetAfterCommit() {},
  resetTextContent: function resetTextContent(domElement) {
    domElement.textContent = '';
  },
  getRootHostContext: function getRootHostContext(instance) {
    return {};
  },
  getChildHostContext: function getChildHostContext(instance) {
    return {};
  },
  shouldSetTextContent: function shouldSetTextContent(type, props) {
    return type === 'textarea' || typeof props.data === 'string' || typeof props.data === 'number' || _typeof(props.dangerouslySetInnerHTML) === 'object' && props.dangerouslySetInnerHTML !== null && typeof props.dangerouslySetInnerHTML.__html === 'string';
  },


  now: function now() {},

  useSyncScheduling: true,

  mutation: {
    appendChild: function appendChild(parentInstance, child) {
      (parentInstance.contentItem || parentInstance).data.push(child);
    },
    appendChildToContainer: function appendChildToContainer(parentInstance, child) {
      (parentInstance.contentItem || parentInstance).data.push(child);
    },
    removeChild: function removeChild(parentInstance, child) {
      for (var i = parentInstance.data.length; i > 0; i--) {
        if (child == parentInstance.data[i]) {
          parentInstance.data[i].destroy();
          break;
        }
      }
    },
    removeChildFromContainer: function removeChildFromContainer(parentInstance, child) {
      for (var i = parentInstance.data.length; i > 0; i--) {
        if (child == parentInstance.data[i]) {
          parentInstance.data[i].destroy();
          break;
        }
      }
    },
    insertBefore: function insertBefore(parentInstance, child, beforeChild) {
      for (var i = parentInstance.data.length; i > 0; i--) {
        parentInstance.data[i + 1] = parentInstance.data[i];
        if (beforeChild == parentInstance.data[i]) {
          parentInstance.data[i] = child;
          child.parent = parentInstance;
          break;
        }
      }
    },
    commitUpdate: function commitUpdate(instance, preparedUpdateQueue) {
      QMLComponent.updateProps(instance, preparedUpdateQueue);
    },
    commitMount: function commitMount(instance, updatePayload, type, oldProps, newProps) {},
    resetTextContent: function resetTextContent(domElement) {
      domElement.textContent = '';
    },
    commitTextUpdate: function commitTextUpdate(textInstance, oldText, newText) {
      textInstance.nodeValue = newText;
    }
  }
});

var ContainerMap = new WeakMap();
function render(reactElements, domContainer) {
  var container = QMLRenderer.createContainer(domContainer);
  var root = new Root(container, QMLRenderer);

  ContainerMap.set(domContainer, root);

  root.render(reactElements);
}

var Root = function () {
  function Root(domRoot, renderer) {
    _classCallCheck(this, Root);

    this.renderer = renderer;
    this.internalRoot = domRoot;
  }

  _createClass(Root, [{
    key: 'render',
    value: function render(children) {
      this.renderer.updateContainer(children, this.internalRoot, null);
    }
  }, {
    key: 'unmount',
    value: function unmount() {
      this.renderer.updateContainer(null, this.internalRoot, null);
    }
  }]);

  return Root;
}();